#ifndef _blackbox_graphics_hh
#define _blackbox_graphics_hh

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/Xresource.h>
#include <X11/xpm.h>
#ifdef SHAPE
#include <X11/extensions/shape.h>
#endif

extern XColor *colors_8bpp;

typedef struct _BColor {
  int r, 
    g,
    b,
    a;
} BColor;


class BImage {
private:
  int depth;
  unsigned long *data;
  unsigned int width, height;

  BColor bg_color;

protected:
  
public:
  //  BImage(void);
  BImage(unsigned int, unsigned int, int, unsigned long * = 0);
  BImage(unsigned int, unsigned int, int, const BColor &);
  BImage(unsigned int, unsigned int, int, unsigned char, unsigned char,
	 unsigned char);
  BImage(XImage *);
  ~BImage(void);
  
  XImage *convertToXImage(Display *, Visual *);
  Pixmap convertToPixmap(Display *, Visual *, Window);
  unsigned long convertToPixel(const BColor &);
  const BColor &convertToBColor(unsigned long);

  Bool getPixel(unsigned int, unsigned int, unsigned long *);
  Bool getPixel(unsigned int, unsigned int, unsigned char *, unsigned char *,
	   unsigned char *);
  Bool putPixel(unsigned int, unsigned int, unsigned char, unsigned char,
	   unsigned char);
  Bool putPixel(unsigned int, unsigned int, unsigned long);

  void setBackgroundColor(const BColor &);
  void setBackgroundColor(unsigned char, unsigned char, unsigned char);
  void renderBevel(void);
  void renderButton(void);
  void invertImage(void);
};


#endif
